#include "AlGaN.h"
//---------------------------------------------------------------------------
double AlGaN::a(double iT,reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.a(iT) + mGa * mGaN.a(iT) );
}
//---------------------------------------------------------------------------
double AlGaN::c(double iT,reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c(iT) + mGa * mGaN.c(iT) );
}
//---------------------------------------------------------------------------
double AlGaN::ea(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "http://www.ioffe.ru/SVA/NSM";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.ea() + mGa * mGaN.ea() );
}
//---------------------------------------------------------------------------
double AlGaN::Eg(double iT,reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 24";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.Eg(iT) + mGa * mGaN.Eg(iT) - mAl*mGa*0.7 );
}
//---------------------------------------------------------------------------
double AlGaN::Dso(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.Dso() + mGa * mGaN.Dso() );
}
//---------------------------------------------------------------------------
double AlGaN::me(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.me() + mGa * mGaN.me() );
}
//---------------------------------------------------------------------------
double AlGaN::mhh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mhh() + mGa * mGaN.mhh() );
}
//---------------------------------------------------------------------------
double AlGaN::mlh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mlh() + mGa * mGaN.mlh() );
}
//---------------------------------------------------------------------------
double AlGaN::meL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.meL() + mGa * mGaN.meL() );
}
//---------------------------------------------------------------------------
double AlGaN::meT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.meT() + mGa * mGaN.meT() );
}
//---------------------------------------------------------------------------
double AlGaN::mhhL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mhhL() + mGa * mGaN.mhhL() );
}
//---------------------------------------------------------------------------
double AlGaN::mhhT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mhhT() + mGa * mGaN.mhhT() );
}
//---------------------------------------------------------------------------
double AlGaN::mlhL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mlhL() + mGa * mGaN.mlhL() );
}
//---------------------------------------------------------------------------
double AlGaN::mlhT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.mlhT() + mGa * mGaN.mlhT() );
}
//------------------------------------------------------------------------------
double AlGaN::mh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "mh = (mlh^3/2+mhh^3/2)^2/3";
	}
	return ( pow(pow(mlh(), 1.5) + pow(mhh(), 1.5), 2./3.) );
}
//---------------------------------------------------------------------------
double AlGaN::c11(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c11() + mGa * mGaN.c11() );
}
//---------------------------------------------------------------------------
double AlGaN::c12(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c12() + mGa * mGaN.c12() );
}
//---------------------------------------------------------------------------
double AlGaN::c13(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c13() + mGa * mGaN.c13() );
}
//---------------------------------------------------------------------------
double AlGaN::c33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c33() + mGa * mGaN.c33() );
}
//---------------------------------------------------------------------------
double AlGaN::c44(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.c44() + mGa * mGaN.c44() );
}
//---------------------------------------------------------------------------
double AlGaN::d13(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.d13() + mGa * mGaN.d13() );
}
//---------------------------------------------------------------------------
double AlGaN::d15(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.d15() + mGa * mGaN.d15() );
}
//---------------------------------------------------------------------------
double AlGaN::d33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.d33() + mGa * mGaN.d33() );
}
//---------------------------------------------------------------------------
double AlGaN::e15(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.e15() + mGa * mGaN.e15() );
}
//---------------------------------------------------------------------------
double AlGaN::e31(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.e31() + mGa * mGaN.e31() );
}
//---------------------------------------------------------------------------
double AlGaN::e33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.e33() + mGa * mGaN.e33() );
}
//---------------------------------------------------------------------------
double AlGaN::Psp(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.Psp() + mGa * mGaN.Psp() );
}
//------------------------------------------------------------------------------
double AlGaN::Nc(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::Nc(iT, me()) );
}
//------------------------------------------------------------------------------
double AlGaN::Nv(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::Nv(iT, mh()) );
}
//------------------------------------------------------------------------------
double AlGaN::ni(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::ni(iT, me(), mh(), Eg(iT)) );
}
//---------------------------------------------------------------------------
double AlGaN::n(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mGa * mGaN.n(iT,iN,iDop) + mAl * mAlN.n(iT,iN,iDop) );
}
//---------------------------------------------------------------------------
double AlGaN::mob(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "wartosc interpolowana z danych dla InN i GaN";
	}
	double mob(0), b(0);

	if(iDop == "Mg") { // Mg-doped
		b = 28.86-16.79*(1.-exp(-mAl/0.055))-9.26*(1-exp(-mAl/0.2));
		mob = pow(mGa,b) * mGaN.mob(iT,iN,iDop);
	}
	else { // undoped/Si-doped
		b = 1.415+19.6*exp(-5.455*mAl);
		mob = mAl * mAlN.mob(iT,iN,iDop) + pow(mGa,b) * mGaN.mob(iT,iN,iDop);
	}
	return mob;
}
//---------------------------------------------------------------------------
double AlGaN::ec(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "-";
	}
    double sigma(0), delta(0);

    // Mg-doped
    if(iDop == "Mg") {
        if(mAl < 0.7) delta = 2.7*mAl + 4.2;
        else delta = 12.2*mAl - 2.4;
    }
    else { // undoped/Si-doped
        if(mAl < 0.7) delta = 0.4*mAl - 0.2;
        else delta = 85.9*mAl*mAl - 117.8*mAl + 40.4;
    }
    return ( cPhys::e * n(300.,iN,iDop) * mob(300.,iN,iDop) * pow(iT/300.,delta) );
}
//---------------------------------------------------------------------------
double AlGaN::k(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
    double k = 1./(mAl/270. + mGa/230. + mAl*mGa*0.4),
           delta = 0.15*mAl - 1.4;

    return ( k*pow(iT/300.,delta) );
}
//---------------------------------------------------------------------------
double AlGaN::cp(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.cp(iT) + mGa * mGaN.cp(iT) );
}
//---------------------------------------------------------------------------
double AlGaN::g(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.g(iT) + mGa * mGaN.g(iT) );
}
//---------------------------------------------------------------------------
double AlGaN::dc(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 164-165";
		ipRef->comment = "wartosc interpolowana z danych dla AlN i GaN";
	}
	return ( mAl * mAlN.dc() + mGa * mGaN.dc() );
}
//---------------------------------------------------------------------------
double AlGaN::nR(double iLam, double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "nR(lam,300K) dla GaN z uwzglednieniem roznicy pomiedzy Eg GaN i AlGaN";
	}
	double tE = cPhys::h_eVc1e9/iLam - (Eg(iT) - mGaN.Eg(300.)),
	       nR(0);

    if (tE > 1.000 && tE < 2.139) nR = 0.013914*tE*tE*tE*tE - 0.096422*tE*tE*tE + 0.27318*tE*tE - 0.27725*tE + 2.3535;      // lambda: 580nm - 1240nm
	if (tE > 2.138 && tE < 3.164) nR = 0.1152*tE*tE*tE - 0.7955*tE*tE + 1.959*tE + 0.68;                                    // lambda: 392nm - 580nm
	if (tE > 3.163 && tE < 3.352) nR = 18.2292*tE*tE*tE - 174.6974*tE*tE + 558.535*tE - 593.164;                            // lambda: 370nm - 392nm
	if (tE > 3.351 && tE < 3.533) nR = 33.63905*tE*tE*tE - 353.1446*tE*tE + 1235.0168*tE - 1436.09;                         // lambda: 351nm - 370nm
	if (tE > 3.532 && tE < 4.101) nR = -0.72116*tE*tE*tE + 8.8092*tE*tE - 35.8878*tE + 51.335;                              // lambda: 336nm - 351nm
    if (tE > 4.100 && tE < 5.000) nR = 0.351664*tE*tE*tE*tE - 6.06337*tE*tE*tE + 39.2317*tE*tE - 112.865*tE + 124.358;      // lambda: 248nm - 336nm

	return nR;
}
//---------------------------------------------------------------------------
double AlGaN::abs(double iLam, double iT, double iN, std::string iDop, reference *ipRef)
{
    double dE = cPhys::h_eVc1e9/iLam - Eg(iT);
	double tN = iN*1e-24;

    if (iDop=="Mg")
		return ( (19000.+200.*tN)*exp(dE/(0.019+0.0001*tN))+(330.+30.*tN)*exp(dE/(0.07+0.0008*tN)) );
    else
	{
		double tNgr = -0.0003878*iLam*iLam + 0.3946*iLam - 90.42;
		if (tN > tNgr) // Perlin
		{
			double tn = n(iT,iN,iDop)*1e-24;
			return ( (33500.*exp(0.08*tn))*exp((-0.00018*tn - 0.0135)*iLam) ); // (przed 17.01.2014 tylko taka zaleznosc dla n-GaN)
		}
		else // Piprek
			return ( (19000.+4000.*tN) * exp(dE/(0.019+0.001*tN)) + (330.+200.*tN) * exp(dE/(0.07+0.016*tN)) );
	}
}
//---------------------------------------------------------------------------
AlGaN::AlGaN(double iAl)
{
    mAl = iAl;
	mGa = 1.-iAl;
}
//---------------------------------------------------------------------------
AlGaN::AlGaN()
{
}
//---------------------------------------------------------------------------
AlGaN::~AlGaN()
{
}
