/*##############################################################################
#                                                                              #
# dane materialowe dla AlInAs                                                  #
#                                                                              #
# data dodania pliku do bazy materialowej: 28-11-2013                          #
# data ostatniej modyfikacji: 17-12-2013                                       #
# autor kodu: LUKASZ PISKORSKI (lukasz.piskorski@p.lodz.pl)                    #
#                                                                              #
##############################################################################*/

#ifndef AlInAs_h
#define AlInAs_h

#include "headers.h"
#include "AlAs.h"
#include "InAs.h"

class AlInAs : public material // Al(x)In(1-x)As
{
	private:
		double mAl, mIn;
		AlAs mAlAs;
		InAs mInAs;

	public:
		double cte(double iT, reference *ipRef=NULL);
		double a(double iT, reference *ipRef=NULL);    
		double Eg(double iT, char iPoint, reference *ipRef=NULL);
		double Eg(double iT, reference *ipRef=NULL);
		double Dso(reference *ipRef=NULL);
		double me(reference *ipRef=NULL);
		double mhh(reference *ipRef=NULL);
		double mlh(reference *ipRef=NULL);
		double mso(reference *ipRef=NULL);
		double mh(reference *ipRef=NULL);
		double Ev(reference *ipRef=NULL);
		double Ec(double iT, reference *ipRef=NULL);
		double ac(reference *ipRef=NULL);
		double av(reference *ipRef=NULL);
		double b(reference *ipRef=NULL);
		double d(reference *ipRef=NULL);
		double c11(reference *ipRef=NULL);
		double c12(reference *ipRef=NULL);
		double c44(reference *ipRef=NULL);
		double Nc(double iT, reference *ipRef=NULL);
		double Nv(double iT, reference *ipRef=NULL);
		double ni(double iT, reference *ipRef=NULL);
		double k(double iT, reference *ipRef=NULL);
		double cp(double iT, reference *ipRef=NULL);
		double g(double iT, reference *ipRef=NULL);
		AlInAs(double iAl);
		AlInAs();    
		virtual ~AlInAs();
};

#endif


