#include "GaN.h"
//---------------------------------------------------------------------------
double GaN::a(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 3.189;
}
//---------------------------------------------------------------------------
double GaN::c(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 5.185;
}
//---------------------------------------------------------------------------
double GaN::ea(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "http://www.ioffe.ru/SVA/NSM";
		ipRef->comment = "-";
	}
	return 4.1;
}
//---------------------------------------------------------------------------
double GaN::Eg(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 24";
		ipRef->comment = "-";
	}
	return ( cFunc::Varshni(3.510, 0.914e-3, 825., iT) );
}
//---------------------------------------------------------------------------
double GaN::Dso(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 0.017;
}
//---------------------------------------------------------------------------
double GaN::me(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "-";
	}
	return 0.20;
}
//---------------------------------------------------------------------------
double GaN::mhh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "-";
	}
	return 1.4;
}
//---------------------------------------------------------------------------
double GaN::mlh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 7-12";
		ipRef->comment = "-";
	}
	return 0.3;
}
//---------------------------------------------------------------------------
double GaN::meL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = " ";
	}
	return 0.22;
}
//---------------------------------------------------------------------------
double GaN::meT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = " ";
	}
	return 0.21;
}
//---------------------------------------------------------------------------
double GaN::mhhL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "mhhL(m0)=-1/(A1+A3), wzor z pracy: Phys. Rev. B, 69, 165204, 2004";
	}
	return 1.67;
}
//---------------------------------------------------------------------------
double GaN::mhhT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "mhhL(m0)=-1/(A2+A4-A5), wzor z pracy: Phys. Rev. B, 69, 165204, 2004";
	}
	return 1.64;
}
//---------------------------------------------------------------------------
double GaN::mlhL(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "mhhL(m0)=-1/(A1+A3), wzor z pracy: Phys. Rev. B, 69, 165204, 2004";
	}
	return 1.67;
}
//---------------------------------------------------------------------------
double GaN::mlhT(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009, p. 231";
		ipRef->comment = "mhhL(m0)=-1/(A2+A4+A5), wzor z pracy: Phys.Rev.B, 69, 165204, 2004 z uwzgl. APL, 67 (17), 2527-9, 1995";
	}
	return 0.15;
}
//------------------------------------------------------------------------------
double GaN::mh(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "mh = (mlh^3/2+mhh^3/2)^2/3";
	}
	return ( pow(pow(mlh(), 1.5) + pow(mhh(), 1.5), 2./3.) );
}
//---------------------------------------------------------------------------
double GaN::c11(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 390.;
}
//---------------------------------------------------------------------------
double GaN::c12(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 145.;
}
//---------------------------------------------------------------------------
double GaN::c13(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 106.;
}
//---------------------------------------------------------------------------
double GaN::c33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 398.;
}
//---------------------------------------------------------------------------
double GaN::c44(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 105.;
}
//---------------------------------------------------------------------------
double GaN::d13(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return -1.6;
}
//---------------------------------------------------------------------------
double GaN::d15(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 3.1;
}
//---------------------------------------------------------------------------
double GaN::d33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return 3.1;
}
//---------------------------------------------------------------------------
double GaN::e15(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "-";
	}
	return -0.167;
}
//---------------------------------------------------------------------------
double GaN::e31(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "-";
	}
	return -0.338;
}
//---------------------------------------------------------------------------
double GaN::e33(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "J. Piprek";
		ipRef->title = "Nitride Semiconductor Devices - Principles and Simulation";
		ipRef->journal = "Wiley VCH, 2007, p. 53";
		ipRef->comment = "-";
	}
	return 0.667;
}
//---------------------------------------------------------------------------
double GaN::Psp(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "I. Vurgaftman and J. R. Meyer";
		ipRef->title = "Band parameters for nitrogen-containing semiconductors";
		ipRef->journal = "Journal of Applied Physics, vol. 94, no. 6, pp. 3675-3696, 2003";
		ipRef->comment = " ";
	}
	return -0.034;
}
//------------------------------------------------------------------------------
double GaN::Nc(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::Nc(iT, me()) );
}
//------------------------------------------------------------------------------
double GaN::Nv(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::Nv(iT, mh()) );
}
//------------------------------------------------------------------------------
double GaN::ni(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "-";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "standardowy wzor";
	}
	return ( cFunc::ni(iT, me(), mh(), Eg(iT)) );
}
//---------------------------------------------------------------------------
double GaN::n(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "-";
	}
	double carr(0);

	if(iDop == "Si") carr = 0.55*pow(iN*1e-6,1.01)*(1.217e-3*iT + 0.638); // Si-doped
	//else if(iDop == "Mg")	carr = 6500.*pow(iN*1e-6,0.71)*(2.884e-4*iT*iT - 0.147*iT + 19.144); // Mg-doped
	else if(iDop == "Mg")	carr = 6500.*pow(iN*1e-6,0.71)*(1250.*exp(-2135./iT)); // Mg-doped	//ref: P. Kozodoy, H. Xing, S.P. DenBaars, U.K. Mishra, A. Saxler, R. Perrin, S. Elhamri, W.C. Mitchel, Heavy doping effects in Mg-doped GaN, Journal of Applied Physics, vol. 87, no. 4, pp. 1832-1835, 2000
	else if(iDop == "O")	carr = 4.328e6*pow(iN*1e-6,0.61)*(6.411e-4*iT + 0.808); // O-doped
	else carr = 2e16; // undoped

	return (carr*1e6);
}
//---------------------------------------------------------------------------
double GaN::mob(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "-";
	}
	double mob(0);

	if(iDop == "Si") mob = 4.164e6*pow(n(300.,iN,"Si")*1e-6,-0.228)*(-1.619e-3*iT + 1.486); // Si-doped
	//else if(iDop == "Mg")	mob = 26.7*exp(-n(300.,iN,"Mg")*1e-24)*(2.495e-5*iT*iT - 2.268e-2*iT + 5.557); // Mg-doped
	else if(iDop == "Mg")	mob = 26.7*exp(-n(300.,iN,"Mg")*1e-24)*(54000.*pow(iT,-1.91)); // Mg-doped	//ref: P. Kozodoy, H. Xing, S.P. DenBaars, U.K. Mishra, A. Saxler, R. Perrin, S. Elhamri, W.C. Mitchel, Heavy doping effects in Mg-doped GaN, Journal of Applied Physics, vol. 87, no. 4, pp. 1832-1835, 2000
	else if(iDop == "O")	mob = 3.066e9*pow(n(300.,iN,"O")*1e-6,-0.398)*(2.030e-5*iT*iT - 1.850e-2*iT + 4.722); // O-doped
	else mob = 800; //undoped

	return (mob*1e-4);
}
//---------------------------------------------------------------------------
double GaN::ec(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "-";
	}
    double carr(0), // koncentracja nosnikow [1/cm^3]
           tmob(0), // ruchliwosc nosnikow [m^2/Vs]
           delta(0), // wykladnik w zaleznosci temperaturowej [-]
           sigma(0);

    // undoped GaN
    carr = 2e22;
    tmob = 800e-4;
    delta = -0.2;

    if(iDop == "Si") { // Si-doped
        carr = n(300.,iN,"Si");
        tmob  = mob(300.,iN,"Si");
        delta = -0.2;
    }
    /*else if(iDop == "Mg") { // Mg-doped
        carr = n(300.,iN,"Mg");
        tmob  = mob(300.,iN,"Mg");
        delta = 4.25;
    }*/
	else if(iDop == "O") { // O-doped
        carr = n(300.,iN,"O");
        tmob  = mob(300.,iN,"O");
        delta = -1.8;
    }
	else { // undoped
        carr = n(300.,iN,"u");
        tmob  = mob(300.,iN,"u");
        delta = -0.2;
	}

	if(iDop == "Mg") // Mg-doped
		return ( cPhys::e * n(iT,iN,"Mg") * mob(iT,iN,"Mg") );
    else
		return ( cPhys::e * carr * tmob * pow(iT/300.,delta) );
}
//---------------------------------------------------------------------------
double GaN::k(double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc, R.P. Sarzala and W. Nakwaski";
		ipRef->title = "Thermal crosstalk in arrays of III-N-based lasers";
		ipRef->journal = "Materials Science and Engineering B, vol. 178, pp. 1395-1402, 2013";
		ipRef->comment = "-";
	}
    double k(0);

	// undoped GaN
	if(mt) k = 230.*pow(tanh(0.001529*pow(mt,0.984)),0.12);
	else k = 230.;

    if(iDop == "Si") k = k*exp(-4.67*iN*1e-27); // Si-doped
    if(iDop == "Mg") k = k*exp(-3.63*iN*1e-27); // Mg-doped

    k = k*pow(iT/300.,-1.4);
    return k;
}
//---------------------------------------------------------------------------
double GaN::cp(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009";
		ipRef->comment = " ";
	}
	return ( 0.42e3 );
}
//---------------------------------------------------------------------------
double GaN::g(double iT, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "S. Adachi";
		ipRef->title = "Properties of Semiconductors Alloys";
		ipRef->journal = "John Wiley and Sons, 2009";
		ipRef->comment = " ";
	}
	return ( 6.0865e3 );
}

//------------------------------------------------------------------------------
double GaN::dc(reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "H. Morkoc";
		ipRef->title = "Nitride Semiconductor Devices - Fundamentals and Applications";
		ipRef->journal = "Wiley-VCH, 2013, pp. 164-165";
		ipRef->comment = "-";
	}
	return ( 10.4 );
}
//---------------------------------------------------------------------------
double GaN::nR(double iLam, double iT, double iN, std::string iDop, reference *ipRef)
{
	if(ipRef!=NULL)
	{
		ipRef->reset();
		ipRef->author = "M. Kuc";
		ipRef->title = "-";
		ipRef->journal = "-";
		ipRef->comment = "na podstawie danych eksperymentalnych z roznych prac";
	}
	double tE = cPhys::h_eVc1e9/iLam - (Eg(iT) - Eg(300.)),
	       nR(0);

    if (tE > 1.000 && tE < 2.139) nR = 0.013914*tE*tE*tE*tE - 0.096422*tE*tE*tE + 0.27318*tE*tE - 0.27725*tE + 2.3535;      // lambda: 580nm - 1240nm
	if (tE > 2.138 && tE < 3.164) nR = 0.1152*tE*tE*tE - 0.7955*tE*tE + 1.959*tE + 0.68;                                    // lambda: 392nm - 580nm
	if (tE > 3.163 && tE < 3.352) nR = 18.2292*tE*tE*tE - 174.6974*tE*tE + 558.535*tE - 593.164;                            // lambda: 370nm - 392nm
	if (tE > 3.351 && tE < 3.533) nR = 33.63905*tE*tE*tE - 353.1446*tE*tE + 1235.0168*tE - 1436.09;                         // lambda: 351nm - 370nm
	if (tE > 3.532 && tE < 4.101) nR = -0.72116*tE*tE*tE + 8.8092*tE*tE - 35.8878*tE + 51.335;                              // lambda: 336nm - 351nm
    if (tE > 4.100 && tE < 5.000) nR = 0.351664*tE*tE*tE*tE - 6.06337*tE*tE*tE + 39.2317*tE*tE - 112.865*tE + 124.358;      // lambda: 248nm - 336nm

	if (iDop == "Si" || iDop == "O") nR = nR*(1. - 1.05e-28*n(iT,iN,iDop));

	return nR;
}
//---------------------------------------------------------------------------
double GaN::abs(double iLam, double iT, double iN, std::string iDop, reference *ipRef)
{
	double dE = cPhys::h_eVc1e9/iLam - Eg(iT); // dE = E - Eg
	double tN = iN*1e-24;

	if (iDop == "Si" || iDop == "O") //Perlin et al., SPIE 8262 (2012) 826216
	{
		double tNgr = -0.0003878*iLam*iLam + 0.3946*iLam - 90.42;
		if (tN > tNgr) // Perlin
		{
			double tn = n(iT,iN,iDop)*1e-24;
			return ( (33500.*exp(0.08*tn))*exp((-0.00018*tn - 0.0135)*iLam) ); // (przed 17.01.2014 tylko taka zaleznosc dla n-GaN)
		}
		else // Piprek
			return ( (19000.+4000.*tN) * exp(dE/(0.019+0.001*tN)) + (330.+200.*tN) * exp(dE/(0.07+0.016*tN)) );
	}
	else //Piprek et al., SPIE 6766 (2007) 67660H
		return ( (19000.+200.*tN) * exp(dE/(0.019+0.0001*tN)) + (330.+30.*tN) * exp(dE/(0.07+0.0008*tN)) );
}
//---------------------------------------------------------------------------
GaN::GaN(double it)
{
	mt = it; // (um)
}
