#include "material_interface.h"
//------------------------------------------------------------------------------
material_interface::material_interface(std::string iName)
{
	if (!iName.compare("AlAs")) mpMat = new AlGaAs(1.);
	else if (!iName.compare("GaAs")) mpMat = new AlGaAs(0.);
	else if (!iName.compare("InAs")) mpMat = new InGaAs(1.);
	else if (!iName.compare("InP"))	mpMat = new InP;
	else if (!iName.compare("GaP"))	mpMat = new GaP;
	else if (!iName.compare("AlP"))	mpMat = new AlP;
	else if (!iName.compare("GaSb")) mpMat = new GaSb;
	else if (!iName.compare("AlSb")) mpMat = new AlSb;
	else if (!iName.compare("InSb")) mpMat = new InSb;
	else if (!iName.compare("GaN")) mpMat = new GaN();
	else if (!iName.compare("GaNzb")) mpMat = new GaNzb;
	else if (!iName.compare("AlNzb")) mpMat = new AlNzb;
	else if (!iName.compare("InNzb")) mpMat = new InNzb;
	else if (!iName.compare("powietrze")) mpMat = new powietrze;
	else if (!iName.compare("Cu")) mpMat = new Cu;
	else if (!iName.compare("Au")) mpMat = new Au;	
	else if (!iName.compare("aSi")) mpMat = new aSi;
	else if (!iName.compare("aSiO2")) mpMat = new aSiO2;
	else if (!iName.compare("AlxOy")) mpMat = new AlxOy;	
	else if (!iName.compare("Ti")) mpMat = new Ti;
	else if (!iName.compare("Pt")) mpMat = new Pt;
	else if (!iName.compare("Ni")) mpMat = new Ni;
	else if (!iName.compare("In")) mpMat = new In;
	else if (!iName.compare("AuGe")) mpMat = new AuGe;
	else if (!iName.compare("cSi")) mpMat = new cSi;
	else if (!iName.compare("ITO")) mpMat = new ITO;
	else if (!iName.compare("BCB")) mpMat = new BCB;	
	else if (!iName.compare("Ag")) mpMat = new Ag;
	else if (!iName.compare("Al")) mpMat = new Al;
	else if (!iName.compare("Be")) mpMat = new Be;
	else if (!iName.compare("Cr")) mpMat = new Cr;
	else if (!iName.compare("Pd")) mpMat = new Pd;
	else if (!iName.compare("W")) mpMat = new W;
	else mpMat = new material;
}
//------------------------------------------------------------------------------
material_interface::material_interface(std::string iName, double iX)
{
	if (!iName.compare("AlGaAs")) mpMat = new AlGaAs(iX);
	else if (!iName.compare("InGaAs")) mpMat = new InGaAs(iX);
	else if (!iName.compare("AlInAs")) mpMat = new AlInAs(iX);
	else if (!iName.compare("GaInP")) mpMat = new GaInP(iX);
	else if (!iName.compare("AlInP")) mpMat = new AlInP(iX);
	else if (!iName.compare("AlGaP")) mpMat = new AlGaP(iX);
	else if (!iName.compare("GaAsP")) mpMat = new GaAsP(iX);
	else if (!iName.compare("InAsP")) mpMat = new InAsP(iX);
	else if (!iName.compare("AlAsP")) mpMat = new AlAsP(iX);
	else if (!iName.compare("GaInSb")) mpMat = new GaInSb(iX);
	else if (!iName.compare("AlInSb")) mpMat = new AlInSb(iX);
	else if (!iName.compare("AlGaSb")) mpMat = new AlGaSb(iX);
	else if (!iName.compare("GaAsSb")) mpMat = new GaAsSb(iX);
	else if (!iName.compare("InAsSb")) mpMat = new InAsSb(iX);
	else if (!iName.compare("AlAsSb")) mpMat = new AlAsSb(iX);
	else if (!iName.compare("GaPSb")) mpMat = new GaPSb(iX);
	else if (!iName.compare("InPSb")) mpMat = new InPSb(iX);
	else if (!iName.compare("AlPSb")) mpMat = new AlPSb(iX);
	else if (!iName.compare("GaNAs")) mpMat = new GaNAs(iX);
	else if (!iName.compare("diament")) mpMat = new diament(iX);		// iX - wartosc w RT
	else if (!iName.compare("GaN")) mpMat = new GaN(iX);				// iX - grubosc wartstwy (um)
	else if (!iName.compare("InN")) mpMat = new InN(iX);				// iX - grubosc wartstwy (um)
	else if (!iName.compare("AlN")) mpMat = new AlN(iX);				// iX - grubosc wartstwy (um)
	else if (!iName.compare("AlGaN")) mpMat = new AlGaN(iX);
	else if (!iName.compare("InGaN")) mpMat = new InGaN(iX);
	else if (!iName.compare("GaN_Si")) mpMat = new GaN_Si(iX);			// tymczasowo
	else if (!iName.compare("GaN_Mg")) mpMat = new GaN_Mg(iX);			// tymczasowo
	else if (!iName.compare("Al5GaN_Si")) mpMat = new Al5GaN_Si(iX);	// tymczasowo
	else if (!iName.compare("Al5GaN_Mg")) mpMat = new Al5GaN_Mg(iX);	// tymczasowo
	else if (!iName.compare("Al10GaN_Si")) mpMat = new Al10GaN_Si(iX);	// tymczasowo
	else if (!iName.compare("Al10GaN_Mg")) mpMat = new Al10GaN_Mg(iX);	// tymczasowo
	else if (!iName.compare("Al30GaN_Mg")) mpMat = new Al30GaN_Mg(iX);	// tymczasowo
	else if (!iName.compare("In10GaN_Si")) mpMat = new In10GaN_Si(iX);	// tymczasowo
	else mpMat = new material;
}
//------------------------------------------------------------------------------
material_interface::material_interface(std::string iName, double iX, double iY)
{
	if (!iName.compare("AlGaAs_g")) mpMat = new AlGaAs_g(iX,iY);
	else if (!iName.compare("AlGaInAs")) mpMat = new AlGaInAs(iX,iY);
	else if (!iName.compare("AlGaInP")) mpMat = new AlGaInP(iX,iY);
	else if (!iName.compare("GaInAsP")) mpMat = new GaInAsP(iX,iY);
	else if (!iName.compare("GaInNAs")) mpMat = new GaInNAs(iX,iY);
	else if (!iName.compare("GaInAsSb")) mpMat = new GaInAsSb(iX,iY);
	else if (!iName.compare("AlGaAsSb")) mpMat = new AlGaAsSb(iX,iY);
	else if (!iName.compare("InAlGaN")) mpMat = new InAlGaN(iX,iY);
	else if (!iName.compare("test01")) mpMat = new test01(iX,iY);
	else if (!iName.compare("test02")) mpMat = new test02(iX,iY);
	else mpMat = new material;
}
//------------------------------------------------------------------------------
material_interface::material_interface(std::string iName, double iX, double iY, double iZ)
{
	if (!iName.compare("GaInNAsSb")) mpMat = new GaInNAsSb(iX,iY,iZ);
	else mpMat = new material;
}
//------------------------------------------------------------------------------
material_interface::material_interface()
{
	mpMat = new material;
}
//------------------------------------------------------------------------------
material_interface::~material_interface()
{
	delete mpMat;
}
//------------------------------------------------------------------------------
namespace cMD
{
	bool matInBase(std::string iMat, int &iInfo)
	{
		/*
		int cmp = -1;
		bool dobry = false;

		char* string = new char[iMat.size()+1];
		strcpy(string,iMat.c_str());

		cmp = strcmp(string, "Ag");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al10GaN_Mg");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al10GaN_Si");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al30GaN_Mg");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al5GaN_Mg");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "Al5GaN_Si");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlAsP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlAsSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaAs_g");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaAsSb");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaInAs");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaInP");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlInAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlInP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlInSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlPSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlxOy");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "aSi");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "aSiO2");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "Au");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "AuGe");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "BCB");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "Be");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "Cr");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "cSi");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "Cu");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "diament");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaAsP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaAsSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInAsP");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInAsSb");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInNAs");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInNAsSb");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaInSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "AlGaP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaN_Mg");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaN_Si");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaNAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaNzb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaPSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "GaSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "In");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "In10GaN_Si");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "InAlGaN");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "InAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InAsP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InAsSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InGaAs");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InGaN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InN");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InNzb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InPSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InSb");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "ITO");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "InAsP");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "Ni");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "Pd");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "powietrze");		if (cmp==0) dobry = true;
		cmp = strcmp(string, "Pt");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "test01");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "test02");			if (cmp==0) dobry = true;
		cmp = strcmp(string, "Ti");				if (cmp==0) dobry = true;
		cmp = strcmp(string, "W");				if (cmp==0) dobry = true;

		if((iMat == "Cu") || (iMat == "Cu ")) dobry = true;

		if(dobry)
		{
			iInfo = 0;
			return true;
		}
		else
		{
			iInfo = -1;
			return false;
		}
		*/
		if ( (!iMat.compare("AlAs")) || (!iMat.compare("AlNzb")) || (!iMat.compare("AlP")) || (!iMat.compare("AlSb")) || (!iMat.compare("AlxOy")) || (!iMat.compare("aSi")) ||
			 (!iMat.compare("aSiO2")) || (!iMat.compare("Au")) || (!iMat.compare("AuGe")) || (!iMat.compare("cSi")) || (!iMat.compare("Cu")) || (!iMat.compare("GaAs")) || 
			 (!iMat.compare("GaNzb")) || (!iMat.compare("GaP")) || (!iMat.compare("GaSb")) || (!iMat.compare("In")) || (!iMat.compare("InAs")) || (!iMat.compare("InNzb")) ||
			 (!iMat.compare("InP")) || (!iMat.compare("InSb")) || (!iMat.compare("ITO")) || (!iMat.compare("Ni")) || (!iMat.compare("BCB")) || (!iMat.compare("powietrze")) || (!iMat.compare("Pt")) ||
			 (!iMat.compare("Ti")) || (!iMat.compare("Ag")) || (!iMat.compare("Al")) || (!iMat.compare("Be")) || (!iMat.compare("Cr")) || (!iMat.compare("Pd")) || (!iMat.compare("W")) )
		{	
			iInfo = 0;
			return true;
		}
		else if ( (!iMat.compare("Al10GaN_Mg")) || (!iMat.compare("Al10GaN_Si")) || (!iMat.compare("Al30GaN_Mg")) || (!iMat.compare("Al5GaN_Mg")) || (!iMat.compare("Al5GaN_Si")) ||
			 (!iMat.compare("AlAsP")) || (!iMat.compare("AlAsSb")) || (!iMat.compare("AlGaAs")) || (!iMat.compare("AlGaN")) || (!iMat.compare("AlGaP")) || (!iMat.compare("AlGaSb")) ||
			 (!iMat.compare("AlInAs")) || (!iMat.compare("AlInP")) || (!iMat.compare("AlInSb")) || (!iMat.compare("AlN")) || (!iMat.compare("AlPSb")) || (!iMat.compare("diament")) ||
			 (!iMat.compare("GaAsP")) || (!iMat.compare("GaAsSb")) || (!iMat.compare("GaInP")) || (!iMat.compare("GaInSb")) || (!iMat.compare("GaN")) || (!iMat.compare("GaN_Mg")) ||
			 (!iMat.compare("GaN_Si")) || (!iMat.compare("GaNAs")) || (!iMat.compare("GaPSb")) || (!iMat.compare("In10GaN_Si")) || (!iMat.compare("InAsP")) || (!iMat.compare("InAsSb")) ||
			 (!iMat.compare("InGaAs")) || (!iMat.compare("InGaN")) || (!iMat.compare("InN")) || (!iMat.compare("InPSb")) )
		{	
			iInfo = 1;
			return true;
		}
		else if ( (!iMat.compare("AlGaAs_g")) || (!iMat.compare("AlGaAsSb")) || (!iMat.compare("AlGaInAs")) || (!iMat.compare("AlGaInP")) || (!iMat.compare("GaInAsP")) ||
			 (!iMat.compare("GaInNAs")) || (!iMat.compare("GaInAsSb")) || (!iMat.compare("InAlGaN")) || (!iMat.compare("test01")) || (!iMat.compare("test02")) )
		{	
			iInfo = 2;
			return true;
		}
		else if ( (!iMat.compare("GaInNAsSb")) )
		{	
			iInfo = 3;
			return true;
		}
		else
		{	
			iInfo = -1;
			return false;
		}
		
	}
	//--------------------------------------------------------------------------
	double par(std::string iPar, std::string iMat, double iX, double iY, double iZ, double iN, std::string iDop, double iLam, double iT, char iDir, int &iInfo)
	{
		double tRes; // result
		
		int tCont; // liczba parametrow do okreslenia skladu materialowego
	
		bool isMat = matInBase(iMat, tCont);
		
		if (!isMat)
		{
			iInfo = -1; // brak materialu
			tRes = -1;
		}
		else
		{
			material_interface *tpMat;
			if (tCont == 0)
				tpMat = new material_interface(iMat);
			else if (tCont == 1)
				tpMat = new material_interface(iMat,iX);
			else if (tCont == 2)
				tpMat = new material_interface(iMat,iX,iY);
			else if (tCont == 3)
				tpMat = new material_interface(iMat,iX,iY,iZ);

			if (iPar == "ec") // ec - electrical conductivity
			{
				if ( (!iMat.compare("AlGaAs")) || (!iMat.compare("InGaAs")) || (!iMat.compare("InP")) || (!iMat.compare("GaInP")) || (!iMat.compare("AlGaInP")) || (!iMat.compare("GaSb")) ||
					(!iMat.compare("AlN")) || (!iMat.compare("GaN")) || (!iMat.compare("InN")) || (!iMat.compare("AlGaN")) || (!iMat.compare("InGaN")) || (!iMat.compare("InAlGaN")) ||
					(!iMat.compare("cSi")) )
					tRes = tpMat->ec(iT,iN,iDop);
				else if ( (!iMat.compare("AlGaAs_g")) )
					tRes = tpMat->ec(iT,iN,iDop,iDir);
				else if ( (!iMat.compare("GaN_Mg")) || (!iMat.compare("GaN_Si"))|| (!iMat.compare("Al10GaN_Mg")) || (!iMat.compare("Al10GaN_Si")) || (!iMat.compare("Al30GaN_Mg")) ||
					(!iMat.compare("Al5GaN_Mg")) || (!iMat.compare("Al5GaN_Si")) || (!iMat.compare("In10GaN_Si")) || (!iMat.compare("Cu")) || (!iMat.compare("In")) || (!iMat.compare("Ti")) ||
					(!iMat.compare("Au")) || (!iMat.compare("Pt")) || (!iMat.compare("Ni")) || (!iMat.compare("AuGe")) || (!iMat.compare("ITO")) || (!iMat.compare("aSiO2")) || 
					(!iMat.compare("diament")) || (!iMat.compare("BCB")) || (!iMat.compare("powietrze")) )
					tRes = tpMat->ec(iT);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else if (iPar == "k") // k - thermal conductivity
			{
				if ( (!iMat.compare("AlAs")) || (!iMat.compare("GaAs")) || (!iMat.compare("InAs")) || (!iMat.compare("AlGaAs")) || (!iMat.compare("AlInAs")) || (!iMat.compare("InGaAs")) ||
					(!iMat.compare("AlGaInAs")) || (!iMat.compare("AlP")) || (!iMat.compare("GaP")) || (!iMat.compare("InP")) || (!iMat.compare("AlGaP")) || (!iMat.compare("AlInP")) ||
					(!iMat.compare("GaInP")) || (!iMat.compare("AlGaInP")) || (!iMat.compare("AlAsP")) || (!iMat.compare("GaAsP")) || (!iMat.compare("InAsP")) || (!iMat.compare("GaInAsP")) ||
					(!iMat.compare("AlSb")) || (!iMat.compare("GaSb")) || (!iMat.compare("InSb")) || (!iMat.compare("AlGaSb")) || (!iMat.compare("AlInSb")) || (!iMat.compare("GaInSb")) ||
					(!iMat.compare("AlAsSb")) || (!iMat.compare("GaAsSb")) || (!iMat.compare("InAsSb")) || (!iMat.compare("GaInAsSb")) || (!iMat.compare("AlGaAsSb")) || (!iMat.compare("AlPSb")) ||
					(!iMat.compare("GaPSb")) || (!iMat.compare("InPSb")) || (!iMat.compare("GaN_Mg")) || (!iMat.compare("GaN_Si"))|| (!iMat.compare("Al10GaN_Mg")) ||
					(!iMat.compare("Al10GaN_Si")) || (!iMat.compare("Al30GaN_Mg")) ||	(!iMat.compare("Al5GaN_Mg")) || (!iMat.compare("Al5GaN_Si")) || (!iMat.compare("In10GaN_Si")) ||
					(!iMat.compare("Cu")) || (!iMat.compare("In")) || (!iMat.compare("Ti")) || (!iMat.compare("Au")) || (!iMat.compare("Pt")) || (!iMat.compare("Ni")) || (!iMat.compare("AuGe")) ||
					(!iMat.compare("ITO")) || (!iMat.compare("cSi")) || (!iMat.compare("aSi")) || (!iMat.compare("aSiO2")) || (!iMat.compare("AlxOy")) || (!iMat.compare("diament")) ||
					(!iMat.compare("BCB")) || (!iMat.compare("powietrze")) )
					tRes = tpMat->k(iT);
				else if ( (!iMat.compare("AlN")) || (!iMat.compare("GaN")) || (!iMat.compare("InN")) || (!iMat.compare("AlGaN")) || (!iMat.compare("InGaN")) || (!iMat.compare("InAlGaN")) )
					tRes = tpMat->k(iT,iN,iDop);
				else if (!iMat.compare("AlGaAs_g"))
					tRes = tpMat->k(iT,iDir);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else if (iPar == "sh") // sp - specific heat
			{
				if ( (!iMat.compare("AlAs")) || (!iMat.compare("GaAs")) || (!iMat.compare("InAs")) || (!iMat.compare("AlGaAs")) || (!iMat.compare("AlInAs")) || (!iMat.compare("InGaAs")) ||
					(!iMat.compare("AlGaInAs")) || (!iMat.compare("AlP")) || (!iMat.compare("GaP")) || (!iMat.compare("InP")) || (!iMat.compare("AlGaP")) || (!iMat.compare("AlInP")) ||
					(!iMat.compare("GaInP")) || (!iMat.compare("AlGaInP")) || (!iMat.compare("AlAsP")) || (!iMat.compare("GaAsP")) || (!iMat.compare("InAsP")) || (!iMat.compare("GaInAsP")) ||
					(!iMat.compare("AlSb")) || (!iMat.compare("GaSb")) || (!iMat.compare("InSb")) || (!iMat.compare("AlGaSb")) || (!iMat.compare("AlInSb")) || (!iMat.compare("GaInSb")) ||
					(!iMat.compare("AlAsSb")) || (!iMat.compare("GaAsSb")) || (!iMat.compare("InAsSb")) || (!iMat.compare("GaInAsSb")) || (!iMat.compare("AlGaAsSb")) || (!iMat.compare("AlPSb")) ||
					(!iMat.compare("GaPSb")) || (!iMat.compare("InPSb")) || (!iMat.compare("GaN_Mg")) || (!iMat.compare("GaN_Si"))|| (!iMat.compare("Al10GaN_Mg")) ||
					(!iMat.compare("Cu")) || (!iMat.compare("In")) || (!iMat.compare("Ti")) || (!iMat.compare("Au")) || (!iMat.compare("Pt")) || (!iMat.compare("Ni")) ||
					(!iMat.compare("diament")) || (!iMat.compare("BCB")) || (!iMat.compare("powietrze")) )
					tRes = tpMat->sh(iT);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}			
			else if (iPar == "g") // g - density
			{
				if ( (!iMat.compare("AlAs")) || (!iMat.compare("GaAs")) || (!iMat.compare("InAs")) || (!iMat.compare("AlGaAs")) || (!iMat.compare("AlInAs")) || (!iMat.compare("InGaAs")) ||
					(!iMat.compare("AlGaInAs")) || (!iMat.compare("AlP")) || (!iMat.compare("GaP")) || (!iMat.compare("InP")) || (!iMat.compare("AlGaP")) || (!iMat.compare("AlInP")) ||
					(!iMat.compare("GaInP")) || (!iMat.compare("AlGaInP")) || (!iMat.compare("AlAsP")) || (!iMat.compare("GaAsP")) || (!iMat.compare("InAsP")) || (!iMat.compare("GaInAsP")) ||
					(!iMat.compare("AlSb")) || (!iMat.compare("GaSb")) || (!iMat.compare("InSb")) || (!iMat.compare("AlGaSb")) || (!iMat.compare("AlInSb")) || (!iMat.compare("GaInSb")) ||
					(!iMat.compare("AlAsSb")) || (!iMat.compare("GaAsSb")) || (!iMat.compare("InAsSb")) || (!iMat.compare("GaInAsSb")) || (!iMat.compare("AlGaAsSb")) || (!iMat.compare("AlPSb")) ||
					(!iMat.compare("GaPSb")) || (!iMat.compare("InPSb")) || (!iMat.compare("GaN_Mg")) || (!iMat.compare("GaN_Si"))|| (!iMat.compare("Al10GaN_Mg")) ||
					(!iMat.compare("Cu")) || (!iMat.compare("In")) || (!iMat.compare("Ti")) || (!iMat.compare("Au")) || (!iMat.compare("Pt")) || (!iMat.compare("Ni")) ||
					(!iMat.compare("diament")) || (!iMat.compare("BCB")) || (!iMat.compare("powietrze")) )
					tRes = tpMat->g(iT);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else if (iPar == "dc") // dc - dielectric constant
			{
				if ( (!iMat.compare("AlAs")) || (!iMat.compare("GaAs")) || (!iMat.compare("AlN")) || (!iMat.compare("GaN")) || (!iMat.compare("InN")) || (!iMat.compare("BCB")) || (!iMat.compare("powietrze")) ||
					(!iMat.compare("AlGaAs")) || (!iMat.compare("AlGaN")) || (!iMat.compare("InGaN")) || (!iMat.compare("InAlGaN")) || (!iMat.compare("Cu")) || (!iMat.compare("AlxOy")) )
					tRes = tpMat->dc();
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else if (iPar == "nR") // nR - refractive index
			{
				if ( (!iMat.compare("AlGaAs")) || (!iMat.compare("InGaAs")) || (!iMat.compare("AlGaInAs")) || (!iMat.compare("InP")) || (!iMat.compare("GaInP")) || 
					(!iMat.compare("AlAsSb")) || (!iMat.compare("AlGaN")) || (!iMat.compare("InGaN")) || (!iMat.compare("InAlGaN")) || (!iMat.compare("GaNAs")) ||
					(!iMat.compare("ITO")) || (!iMat.compare("aSi")) || (!iMat.compare("aSiO2")) || (!iMat.compare("AlxOy")) || (!iMat.compare("powietrze")) || (!iMat.compare("Au")) ||
					(!iMat.compare("Ag")) || (!iMat.compare("Al")) || (!iMat.compare("Be")) || (!iMat.compare("Cr")) || (!iMat.compare("Cu")) || (!iMat.compare("Ni")) || (!iMat.compare("Pd")) || (!iMat.compare("Pt")) || 
					(!iMat.compare("Ti")) || (!iMat.compare("W")) )
					tRes = tpMat->nR(iLam,iT);
				else if ( (!iMat.compare("GaSb")) || (!iMat.compare("AlN")) || (!iMat.compare("GaN")) || (!iMat.compare("InN")) )
					tRes = tpMat->nR(iLam,iT,iN,iDop);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else if (iPar == "abs") // abs - absorption coefficient
			{
				if ( (!iMat.compare("ITO")) || (!iMat.compare("powietrze")) || (!iMat.compare("Au")) || (!iMat.compare("Ag")) || (!iMat.compare("Al")) || (!iMat.compare("Be")) ||
					(!iMat.compare("Cr")) || (!iMat.compare("Cu")) || (!iMat.compare("Ni")) || (!iMat.compare("Pd")) || (!iMat.compare("Pt")) || (!iMat.compare("Ti")) || (!iMat.compare("W")) )
					tRes = tpMat->abs(iLam,iT);
				else if ( (!iMat.compare("AlGaAs")) || (!iMat.compare("InGaAs")) || (!iMat.compare("InP")) || (!iMat.compare("GaSb")) || (!iMat.compare("AlAsSb")) || 
					(!iMat.compare("AlN")) || (!iMat.compare("GaN")) || (!iMat.compare("InN")) || (!iMat.compare("AlGaN")) || (!iMat.compare("InGaN")) || (!iMat.compare("InAlGaN")) )
					tRes = tpMat->abs(iLam,iT,iN,iDop);
				else
				{
					iInfo = -2; // brak takiego parametru dla podanego materialu
					tRes = -1.;
				}
			}
			else
			{
				iInfo = -3; // brak takiego parametru lub fragment kodu do zwracania tego parametru nie zostal jeszcze napisany
				tRes = -1.;
			}
			
			delete tpMat;
		}

		return tRes;
	}
}