#include "materials.h"

#include "MaterialDataBase/Ag.h"
#include "MaterialDataBase/Al10GaN_Mg.h"
#include "MaterialDataBase/Al10GaN_Si.h"
#include "MaterialDataBase/Al30GaN_Mg.h"
#include "MaterialDataBase/Al5GaN_Mg.h"
#include "MaterialDataBase/Al5GaN_Si.h"
#include "MaterialDataBase/AlAs.h"
#include "MaterialDataBase/AlAsP.h"
#include "MaterialDataBase/AlAsSb.h"
#include "MaterialDataBase/AlGaAs_g.h"
#include "MaterialDataBase/AlGaAs.h"
#include "MaterialDataBase/AlGaAsSb.h"
#include "MaterialDataBase/AlGaInAs.h"
#include "MaterialDataBase/AlGaInP.h"
#include "MaterialDataBase/AlGaN.h"
#include "MaterialDataBase/AlGaP.h"
#include "MaterialDataBase/AlGaSb.h"
#include "MaterialDataBase/Al.h"
#include "MaterialDataBase/AlInAs.h"
#include "MaterialDataBase/AlInP.h"
#include "MaterialDataBase/AlInSb.h"
#include "MaterialDataBase/AlN.h"
#include "MaterialDataBase/AlNzb.h"
#include "MaterialDataBase/AlP.h"
#include "MaterialDataBase/AlPSb.h"
#include "MaterialDataBase/AlSb.h"
#include "MaterialDataBase/AlxOy.h"
#include "MaterialDataBase/aSi.h"
#include "MaterialDataBase/aSiO2.h"
#include "MaterialDataBase/AuGe.h"
#include "MaterialDataBase/Au.h"
#include "MaterialDataBase/BCB.h"
#include "MaterialDataBase/Be.h"
#include "MaterialDataBase/Cr.h"
#include "MaterialDataBase/cSi.h"
#include "MaterialDataBase/Cu.h"
#include "MaterialDataBase/diament.h"
#include "MaterialDataBase/GaAs.h"
#include "MaterialDataBase/GaAsP.h"
#include "MaterialDataBase/GaAsSb.h"
#include "MaterialDataBase/GaInAsP.h"
#include "MaterialDataBase/GaInAsSb.h"
#include "MaterialDataBase/GaInNAs.h"
#include "MaterialDataBase/GaInNAsSb.h"
#include "MaterialDataBase/GaInP.h"
#include "MaterialDataBase/GaInSb.h"
#include "MaterialDataBase/GaNAs.h"
#include "MaterialDataBase/GaN.h"
#include "MaterialDataBase/GaN_Mg.h"
#include "MaterialDataBase/GaN_Si.h"
#include "MaterialDataBase/GaNzb.h"
#include "MaterialDataBase/GaP.h"
#include "MaterialDataBase/GaPSb.h"
#include "MaterialDataBase/GaSb.h"
#include "MaterialDataBase/headers.h"
#include "MaterialDataBase/In10GaN_Si.h"
#include "MaterialDataBase/InAlGaN.h"
#include "MaterialDataBase/InAs.h"
#include "MaterialDataBase/InAsP.h"
#include "MaterialDataBase/InAsSb.h"
#include "MaterialDataBase/InGaAs.h"
#include "MaterialDataBase/InGaN.h"
#include "MaterialDataBase/In.h"
#include "MaterialDataBase/InN.h"
#include "MaterialDataBase/InNzb.h"
#include "MaterialDataBase/InP.h"
#include "MaterialDataBase/InPSb.h"
#include "MaterialDataBase/InSb.h"
#include "MaterialDataBase/ITO.h"
#include "MaterialDataBase/material.h"
#include "MaterialDataBase/material_interface.h"
#include "MaterialDataBase/Ni.h"
#include "MaterialDataBase/Pd.h"
#include "MaterialDataBase/powietrze.h"
#include "MaterialDataBase/Pt.h"
#include "MaterialDataBase/reference.h"
#include "MaterialDataBase/Si3N4.h"
#include "MaterialDataBase/test01.h"
#include "MaterialDataBase/test02.h"
#include "MaterialDataBase/Ti.h"
#include "MaterialDataBase/W.h"


REGISTER_SIMPLE(Ag);
REGISTER_SIMPLE(Al);
REGISTER_SIMPLE(AlAs);
REGISTER_TERTIARY(AlAsP, As);
REGISTER_TERTIARY_DOPED(AlAsSb, As, Te);
REGISTER_TERTIARY_DOPED(AlGaAs, Al, Si, C, Zn, Be, Te, Se);
REGISTER_QUATERNARY(AlGaAsSb, Al, As);
REGISTER_QUATERNARY(AlGaInAs, Al, Ga);
REGISTER_QUATERNARY_DOPED(AlGaInP, Al, Ga, Si, Zn, Se, Be);
REGISTER_TERTIARY_DOPED(AlGaN, Al, Si, Mg);
REGISTER_TERTIARY(AlGaP, Al);
REGISTER_TERTIARY(AlGaSb, Al);
REGISTER_TERTIARY(AlInAs, Al);
REGISTER_TERTIARY(AlInP, Al);
REGISTER_TERTIARY(AlInSb, Al);
REGISTER_NITRIDE_DOPED(AlN, Si, Mg);
REGISTER_SIMPLE(AlNzb);
REGISTER_SIMPLE(AlP);
REGISTER_TERTIARY(AlPSb, P);
REGISTER_SIMPLE(AlSb);
REGISTER_SIMPLE(AlxOy);
REGISTER_SIMPLE(aSi);
REGISTER_SIMPLE(aSiO2);
REGISTER_SIMPLE(Au);
REGISTER_SIMPLE(AuGe);
REGISTER_SIMPLE(BCB);
REGISTER_SIMPLE(Be);
REGISTER_SIMPLE(Cr);
REGISTER_BINARY_DOPED(cSi, P, As, Sb, B);
REGISTER_SIMPLE(Cu);
REGISTER_SIMPLE(GaAs);
REGISTER_TERTIARY(GaAsP, As);
REGISTER_TERTIARY(GaAsSb, As);
REGISTER_QUATERNARY(GaInAsP, Ga, As);
REGISTER_QUATERNARY(GaInAsSb, Ga, As);
REGISTER_QUATERNARY(GaInNAs, Ga, N);
REGISTER_TERTIARY_DOPED(GaInP, Ga, Si, Zn, Se, Sn, C, Be, Cd);
REGISTER_TERTIARY(GaInSb, Ga);
REGISTER_NITRIDE_DOPED(GaN, Si, Mg, O);
REGISTER_TERTIARY(GaNAs, N);
REGISTER_SIMPLE(GaNzb);
REGISTER_SIMPLE(GaP);
REGISTER_TERTIARY(GaPSb, P);
REGISTER_SIMPLE(GaSb);
REGISTER_SIMPLE(In);
REGISTER_QUATERNARY(InAlGaN, In, Al);
REGISTER_SIMPLE(InAs);
REGISTER_TERTIARY(InAsP, As);
REGISTER_TERTIARY(InAsSb, As);
REGISTER_TERTIARY_DOPED(InGaAs, In, Si, C, Zn, Be, Te, Se, Sn);
REGISTER_TERTIARY_DOPED(InGaN, Al, Si, Mg);
REGISTER_NITRIDE_DOPED(InN, Si, Mg);
REGISTER_SIMPLE(InNzb);
REGISTER_BINARY_DOPED(InP, Si, Zn, Be, C, Te, S);
REGISTER_TERTIARY(InPSb, P);
REGISTER_SIMPLE(InSb);
REGISTER_SIMPLE(ITO);
REGISTER_SIMPLE(Ni);
REGISTER_SIMPLE(Pd);
REGISTER_SIMPLE(powietrze);
REGISTER_SIMPLE(Pt);
REGISTER_SIMPLE(Si3N4);
REGISTER_SIMPLE(Ti);
REGISTER_SIMPLE(W);
